####################################
# V1.7.0
####################################

## Added Features:
  - #1464: Upgrade for PHP version 8.1 to 8.4 and MYSql 8 compatibility
  - #1492: Added new configuration for bed types in a room type in back-office.
  - #1411: Added our properties controller in the front office, and updated the store detail flow in the back office.
  - #1488: Added option to add multiple restrictions in a single Advance price for a room type in back-office.
  - #1346: Added feature to create Advanced price rules for multiple room types at once in the back office.
  - #1374: Added feature for admin to add/update multiple rooms at once in the room tab in room type page in the back office.
  - #1412: Added new option to add bed types for a room type in back office.
  - #1358: Added new service product addition while order add and edit and service price edit while order creation in Back-office
  - #1399: Added standard product flow in QloApps
  - #1495: Added registration number, fax detail and icons on contact us page in the front-office.
  - #1354: Added an option for the admin to skip sending order confirmation emails when creating a new order from the admin orders page in the back office.
  - #1369: Added Configuration option for the Admin to include or exclude the website name in the email subject.
  - #1382: Added new columns to exported CSV using admin export in back office.

## Back Office:
- Improvements:
  - #1524: Updated the hotel and room type filters on the advance price rules listing in the back-office.
  - #1363: Updated the stay overs KPI with occupied KPI in AdminDashboard and in AdminOrders controller in back office.
  - #1496: Updated the KPIs will now include data up to and including the current date in the back office
  - #1490: Updated the toolbar title for the order page on list display in the back-office.
  - #1409: Updated short description save/update process for hotel, services and room types.
  - #1408: Updated moved customer selection block before cart details block in the add new order page in the back office.
  - #1506: Removed generate PDF button from the top of the credit slip controller, added button to generate voucher in the back-office.
  - #1351: Updated hide the "Future Booking" popup button in the Room tab of the Room Type page when no future bookings exist.
  - #1350: Updated password is no longer required while creating a customer from the back office.
  - #1344: Replaced Product id with Room type id in the CSV samples and in CSV import controller
  - #1337: Updated the flow of date from and date to for advance price rule create and update, and fixed price issue occurring during booking creation in back office.
  - #1392: Added trim to the searched text on the "Modules Catalog" page in the Back Office.
  - #1326: Updated payment_type for Free order and back-office orders
  - #1327: Added total rooms column in refund request list and detail page in back-officee
  - #1527: Added help text for length of stay in Room type page in back-office

- Bugs Fixed:
  - #1529: Fixed Room unit price in the add order page is not correct if a specific price is already created and then advance price is applied of room type original price in the back-office.
  - #1516: Fixed The docs and customer guest are not deleted on order and customer delete process using the data cleaner in back-office.
  - #1501: Fixed Cart rules are saved with empty room type restriction in the back office.
  - #1499: Fixed Getting error when customer cancel booking when order status is Awaiting payment
  - #1498: Fixed When booking is deleted while reallocating, refund requests are not deleted
  - #1489: Fixed It shows order status “Booked” when all rooms are deleted except refunded rooms
  - #1484: Fixed Incorrect texts in the language form and order preferences in the back-office.
  - #1483: Fixed Showing no customer found while adding new customers while creating new order in the back-office.
  - #1477: Fixed Admin in unable to delete some refund statuses in back-office
  - #1475: Fixed Added fax, Max checkout date error for the hotel import and added warning in booking import in case the Room type does not exists in csv import process in back-office.
  - #1474: Fixed The payment page link is generated with SSL as false in the admin order controller in the order page in back office.
  - #1469: Fixed Added missing validation in the back-office.
  - #1468: Fixed Multiple requests are sent in case admin clicks on the "add new customer" button multiple times in the back-office.
  - #1467: Fixed Filter related issues in the Back office
  - #1449: Fixed When booking is created from back-office with a partial amount, then full payment is displayed in the Payment type KPI
  - #1421: Fixed Translation issues in the back office
  - #1420: Fixed Undefined index booking_dates notice in rooms tab and incorrect information in price tab in manage room types in the back-office.
  - #1419: Fixed The customer default address is removed from address list in address tab if admin edits the default address from order detail page in back-office
  - #1414: Fixed The text in the AdminTranslation controller is not in context language but in the selected language if the selected language to translate already exists in translations controller in back office.
  - #1398: Fixed Service product is not removed from the cart on the room deletion process from cart in the back office.
  - #1397: Fixed Success message not showing on removing the last page from quick access in back office
  - #1394: Fixed Data in order's cart do not update while updating/deleting rooms and services in order edit process from the back office
  - #1387: Fixed Extra Information field value not saved while adding a room in room type in back office.
  - #1385: Fixed Translation issue on the booking page in the Back Office
  - #1383: Fixed Employees with only Add access unable to create orders from Back Office
  - #1377: Fixed Prevented negative values in "Max Size of Short Description" field in backoffice.
  - #1380: Fixed Hide tax rule selection for auto-added service products in the back office.
  - #1375: Fixed Refund can be enabled in Hotel even if it is Disabled from Refund Rules page Globally
  - #1370: Fixed Undefined index issues in the AdminController and Tab class.
  - #1368: Fixed The admin is no longer redirected from the checkout page to the "Book Now" page after deleting a room from the cart in the back office.
  - #1364: Fixed The design of header toolbar is not responsive in back office.
  - #1360: Fixed The order status cannot be changed to Partial payment received until at least one partial payment has been made for this order.
  - #1341: Fixed Unable to change date range of room booking after room swapping in Back-office
  - #1339: Fixed The disabled date event was not removed when deleted using the delete button from the Disable Dates calendar in the back office.
  - #1336: Fixed All carts gets emptied if admin rapidly clicks the remove button twice while removing a room from the cart on the Book Now page in the back office.
  - #1332: Fixed The Occupancy column was not appearing in the cart details after the admin added a customer to the cart on the "Book Now" page in the back office.
  - #1308: Fixed Order and invoice price calculation issues that occurred after updating an order in the back office.
  - #1318: Fixed A new cart is created every time the admin adds a room to the cart
  - #1323: Fixed If room price is edited for two hotels in the cart second hotel room price is not changes after order
  - #1331: Fixed Notice should be mentioned if no room types are available for reallocation in order detail page in back-office

## Front Office:
- Improvements:
  - #1388: Added CSRF token validation on user logout at Front office
  - #1366: Updated the search flow of search result page in the front office.

- Bugs Fixed:
  - #1480: Fixed text, filter and display issues in the hotel filter block module in the front-office.
  - #1330: Fixed getting issue when guest user try to change his mobile number during checkout.
  - #1396: Fixed multiple orders creation issue in cheque and bankwire payment gateways in front office.
  - #1359: Fixed emails regarding awaiting payment should not be sent to customers if the payment amount in the order is 0.
  - #1328: Fixed same location is showing on map for all hotels at order detail page of guest order tracking
  - #1340: Fixed service products and extra demands remains selected even when rooms were unavailable for the selected date range in the front office.
  - #1348: Fixed search panel on landing page in front office does not displays properly if there are any issues in the JS.
  - #1526: Fixed if available for order is disabled, then name of the extra service does not show on checkout page in front office
  - #1406: Fixed translation issues in the front office
  - #1372: Fixed date range picker opens at the top even when there's insufficient space.
  - #1324: Fixed undefined index when a product in cart is neither a booking product nor service product in front-office
  - #1410: Fixed the hotel name in the search panel was exceeding the parent container's width In front office.
  - #1478: Fixed tax label is displayed on order detail and order confirmation pages in the front-office even if the 'Display tax label' is disabled for the country.

## Core:
- Improvements:
  - #1355: Updated the flow for the max order date and min booking offset.
  - #1528: Updated the Google Maps API endpoints for improved performance and compatibility for the front and back-office.
  - #1390: Updated the flow of customer message and customer service.
  - #1505: Added secured queries with type casting to prevent SQL injection and sanitized values against XSS.
  - #1413: Added module and core upgrade Files for version 1.6.1
  - #1416: Added hotel address and removed hotel column from the room type table in the booking invoice.
  - #1470: Optimized the tree creation process from the helper tree, added option to add prefix in hotel helper while generating the tree data.
  - #1389: Updated the cart customer guest detail flow.
  - #1378: Optimized Functions and removed unnecessary object initialization to reduce overhead.
  - #1371: Updated hook_display_pdf will now fill the whole page in the PDF
  - #1365: Added new column phone in the customer table
  - #1357: Updated date format in hotel booking demands and removed non required validation from validateCartBookings() function.
  - #1356: Added new column 'planned checkout' in the hotel booking detail.
  - #1352: Updated the theme preview image in back office and front office block image on install page
  - #1347: Updated parameters in hook 'actionRoomReallocateAfter'.
  - #1342: Added occupancy in the functions and their calls in the QloApps core.
  - #1481: Added the current installed version of QloApps in the Database on install process.
  - #1345: Removed Autoupgrade module from the QloApps core.
  - #1530: Updated: NOTICE OF LICENSE in the templates, css, php and js files

- Bugs Fixed:
  - #1511: Fixed: Tax rate calculation and breakdown in order invoice
  - #1329: Fixed wrong hooks parameters code in AdminProductsController.php
  - #1487: Fixed getting payment issue after applying restriction on the coupon just before checkout
  - #1381: Fixed fatal error caused by the getList() function being called twice when the action is set to export, affecting the hookListingFieldsModifier.
  - #1379: Fixed missing hotel name column in credit slip in the PDF.
  - #1517: Fixed empty ranges filters are set in the cookies after filter search in the back-office.
  - #1338: Fixed php notices are shown if module overrides are removed using the removeOverride() function.
  - #1311: Fixed installation issue in multiple languages (Czech, Italian and Vietnamese)
  - #1423: Fixed cart changes are not reflected when using the cache
  - #1417: Fixed cache is not cleaned and some data is deleted incorrectly when using cleaner module.
  - #1335: Removed quantity validation for auto added service products.
  - #1334: Fixed wrong parameter sent instead of quantity parameter in function call in room block module.

## Web Services:
- Bugs Fixed:
  - #1322: Fixed incorrect data in Availability & Rates seach API with Date Wise Break-down
  - #1471: Fixed issues in bookings and services webservices and removed the specific management qlo webservice.
  - #1402: Fixed create new customer if guest email is sent via booking webservice.
  - #1407: Fixed services Prices are set incorrectly in the bookings webservice PUT request
  - #1361: Fixed unable to upload Images of Hotels and Extra Services through API
  - #1333: Fixed auto added services are not visible in the response of bookings webservice.
  - #1321: Fixed getting Undefined index: show_full_date while create order using webservice

####################################
# V1.6.1
####################################

## Added Features:
  - #941: Admin can add custom prices for facilities and services while editing order.
  - #890: Service products can now be assigned to a room type from room type edit page at back office.
  - #881: Address is not required in booking/order flow
  - #784: Admin can add partial order payment when creating a new booking.
  - #901: Added upgrade/degrade of rooms while reallocation and also fixed reallocation and swapping issues.
  - #833: Added 'Show at front office' option to enable/disable booking from front office.
  - #877: Added new module for extra service and facilities statistics.
  - #830: Added option to disable backdate order from superadmin and employees.
  - #896: Added configuration for showing prices in Order list in (Default currency or Payment Currency).
  - #1105: Added option for modules to manipulate KPI data.
  - #918: New design of order detail page of the customer
  - #918: New design of order detail page of the admin in back-office
  - #870: New design for KPIs in back-office
  - #1080: Added option 'Maximum Login Attempts' on Preferences > Maintenance page to allow certain number of employee login attempts.
  - #947: Added KPIs on orders list page in back-office.
  - #1124: Added new KPIs in order view page in the Back-office.
  - #1264: Added Seo fields in manage hotel controller in the back-office
  - #850: Added language dropdown on maintenance page.
  - #1108: Added email template for Partial payment received status.
  - #1164: Added option to add/edit customer address from order detail page of Back office.
  - #819: Added configuration to show or hide 'Date of Birth' field in customer registration and customer information form at front office.
  - #1065: Added Option to view frequent customer in back office customer page.
  - #1094: Added Admin can set voucher expiry along with voucher when managing refund request.
  - #1167: Added Confirmation modal when deleting cart rules and while changing credit slip status.
  - #1204: Added option to show page loader in back office.
  - #1191: Added webservice for bookings management.
  - #1170: Added date wise breakdown in Availability and rates search API
  - #776: Added breadcrumbs on my account pages at front office.
  - #894: Added process to allow modules to override module admin and front controllers.
  - #1168: Added hotel description in room type page in front office.
  - #1092: Added new sorting option "recommended" in search result page.
  - #775: Added demo service products for categories Meals and Transfers.
  - #962: Added new categories in demo data.
  - #882: Added links of Suggested Modules and Themes during installation.
  - #1195: Added process for smarty template overriding.
  - #937: Added hotel wise restriction on the customer messages belonging to an order.
  - #1028: Added hotel wise restrictions on the order notifications for the employee.
  - #1138: Added parameters in PatmentModule::validateOrder() function to prevent the emails on the order validation process.
  - #883: Added 'Save and stay' button on missing pages at back office.
  - Added new hooks in #938, #880, #928, #935, #1121, #1132, #1197, #812, #887, #1197, #1271

## Back Office:
- Improvements:
    - #891: Updated design of back office page toolbar
    - #1031: Updated tab wise permission restriction on the hotel feature delete process.
    - #1188: Updated hotel features assigning process in the back office.
    - #965: Improved AdminImportController to handle the csv files required in managing PMS.
    - #1241: Updated condition to assign default category on the AdminCustomNavigationLinkSettingController in the back-office.
    - #1185: Updated the tab menu list of the hotel reservation system in the back office.
    - #1067: Updated the icon for the invoice in search list in the back office
    - #1064: Updated room type position update field alert message in back office
    - #1186: Added `Add new order` button on the admin orders list page.
    - #1025: Added hotel name and room type name in the list in the hotel room block module, added hotel search option while creating new room block.
    - #1187: Added feature in tree to select all children node when parent node is selected and fixed some text issue
    - #1119: Added check-all and uncheck-all option in the tree for normal products and scroll bar for the rendered tree.
    - #1267: Added validations for backoffice list filters for text fields.
    - #826: Updated filter by Places panel removed and added advanced filters and room type positioning on Manage Room Types page at back office
    - #808: Updated move Week Days list in a new row on Advanced Price Rule form at back office
    - #884: Added breadcrumbs for Hotel Booking and Reservation System module controllers under Hotel Reservation System > Settings.
    - #944: Added Accurate page name display in "Visitors online" statistics.
    - #736: Updated display voucher table only if needed on Order view at back office
    - #811: Updated code commented for Pagination panel on Preferences > Room Types page at back office
    - #1291: Updated validation for 'Consider guest as child below age' in the back-office and removed child ages from occupancy fields in case 'Maximum children' for a room type is 0 from front-office.
    - #801: Updated code for unused addons login feature at the back office has been commented
    - #799: Removed subtabs Search Engines and Referers from Stats tab at back office
    - #1158: Updated the trademark of the head tag of the admin login page
    - #1068: Added validation for the social name in the admin genders controller and changed the neutral gender to the other.
    - #1149: Updated preparation time to minimum booking offset and its definition in the admin order preferences controller.
    - #1088: Updated customer deletion and ban process and added filters for the admin to view the banned customers.
    - #888: Updated default listing order of rooms on admin book now page to ascending order of room database ID.
    - #1042: Updated created different block for the customer general and customer KPI configuration in the customer preferences in the admin office.
    - #1039: Updated abandoned cart Filter and the Abandoned cart KPI in the admin carts controller.
    - #939: Updated optimized search results in the admin search page.
    - #873: Removed decimal values from admin stats graph axis where not required
    - #815: Updated added Rooms filter and added suggestions for Hotel and Room type filter inputs on admin orders list page
    - #807: Added Warning for maximum quantity of service products in Extra Services popup when creating or editing a booking at back office.
    - #789: Updated set default occupancy chosen on search results, room type detail and admin book now pages
    - #1169: Updated info for convenience fees products and taxes breakup in admin order detail page.
    - #771: Updated design of 'Delete voucher' button has been changed to button instead of text on admin Order detail page
    - #770: Updated disable cart popup button on admin Book Now page if cart is empty
    - #987: Improved Statstics data in admin stats page
    - #926: Updated renamed tab Configure to Rooms on Catalog > Manage Room Types page
    - #863: Updated "stats dashboard" page conversion graph design
    - #835: Updated make Customer Groups inaccessible if option Customer Groups is disabled on Advanced Parameters > Performance page
    - #827: Updated use Chosen plugin to select hotel on Catalog > Add Room Type page
    - #748: Updated latest logs created will be displayed at the top on Advanced Parameters > Logs page
    - #798: Updated move navbar Customer Support contact settings to Hotel Reservation System > Settings > General Settings page
    - #1268: Updated error message for cart rule validation
    - #1176: Updated the disabled dates interface, add and update process.
    - #1165: Displayed image Upload Sizes for Hotel Amenities and Interior Blocks
    - #1139: Updated the validation for the city name.
    - #1135: Updated order Return states names changes and Translations added
    - #1103: Updated validations of order status changes while changing order status using bulk action
    - #1101: Updated order edit validations for refunded or cancelled bookings
    - #980: Updated room type pre-tax operating cost validation message
    - #967: Updated display Helper list filters above list table using new list header option
    - #865: Updated stats are now shown according to employee hotel access
    - #851: Updated same day room checkin - checkout and select time along with checkin - checkout
    - #841: Updated prevent room deletion and room status update to inactive when room has future booking
    - #1145: Updated empty dropdown will appear if no options are available and empty message is not set.
    - #1070: Updated validations for Hotel address when add a new hotel
    - #837: Updated resolve multiple specific price visible for a single catalog rule
    - #1146: Udpated Text of column 'tax' to 'Tax rule' in both 'Additional Facilities' & 'Service Products' tab of room type detail page
    - #1041: Added 'Show at front' column and updated display of 'Advanced payment' column in the room type list in back office.
    - #1237: Removed Save and stay button for the new voucher popup on the Book Now page in the back-office.
    - #898: Removed association tab from back office room type page
    - #1134: Removed the gender icon from customer information in the AdminCartsController
    - #1059: Removed order Currency filter was added multiple time in admin orders page
    - #930: Removed hotel wise access restriction for the employees on AdminCustomerController
    - #875: Removed information block for 'Save global page views' from admin stats where not required
    - #869: Removed custom scrollbar design for badges on admin dashboard
    - #1115: Removed retail price field with tax from manage service product panel
    - #932: Removed hotel wise access for the employees on the customers addresses
    - #769: Removed delivery related fields from Orders > Statuses list page and new Order State form
    - #726: Removed country Options section from Localization > Countries page
    - #1016: Added display global max order date and global preparation time in the restriction tab in manage hotels.

- Bugs Fixed:
    - #866:  Fixed Arrangement of row and column in csv files.
    - #1284: Fixed getting fatal error on AdminHotelRoomsBookingController when an employee adds an invalid date in the search booking form in back-office.
    - #1257: Fixed available fields column of one tab is reset from another tab in backoffice
    - #1251: Fixed occupancy selection panel design issue in Backoffice book now page
    - #1248: Fixed wrong process for the hotel name for 'most viewed' room types for dashboard in the back-office.
    - #1243: Fixed wrong addresses search and hotel access wise Service products search results in AdminSearchController in the back-office.
    - #1240: Fixed the design issues with the pop up in the search form in Book Now page in back-office.
    - #1239: Fixed hotel wise restriction not working in AdminCustomersThreadsController in back-office.
    - #1233: Fixed getting Fatal error while trying to use filter in the AdminTabsController in the back-office.
    - #1231: Fixed wrong values selected in Select type filter when submitting with empty value in all render-list filters in the back-office.
    - #1230: Fixed the add new button disappears when the controller display type is not empty in admin controllers in the back-office.
    - #1228: Fixed information alert for 'Max quantity allow' field does not hide if 'Allow ordering of multiple quantities' is disabled while adding/editing service products in back-office
    - #1214: Fixed wrong value of the Messages KPI in AdminOrdersController in back-office.
    - #1213: Fixed wrong value of Gender percentage in Customers KPI in the AdminCustomerController in the back-office
    - #1212: Fixed wrong total number of customers in the render-list in the AdminCustomerController in the back-office
    - #1159: Fixed total count for the service products is incorrect in the list in back office.
    - #1125: Fixed invoice data is not correct when multiple invoices created in an order from back-office
    - #1122: Fixed currency conversion issue in order if default currency is changed while creating booking from back-office
    - #1106: Fixed refund amount not converted while changing the currency of the Order in back office
    - #1102: Fixed unable to add discount coupon of 100% on order detail page from back-office
    - #1063: Fixed order prices decimal value not shown according to configuration when booking from back office
    - #1049: Fixed warnings for invalid IMAP configuration after saving the default message in the contact in the back office.
    - #1046: Fixed getting errors in the back office if the id in the URL is updated manually to an invalid one.
    - #1045: Fixed the email selection process while creating new address for the customer and back button for the AdminAddressController.
    - #1043: Fixed the customer page in the back office showing non required information.
    - #1030: Fixed the errors not being displayed in the AdminThemesController in the back office.
    - #1023: Fixed backoffice design issue in RTL language
    - #1004: Fixed issues in the process of booking creation from back office
    - #997: Fixed getting fatal error on order detail page if entered invalid order ID in URL in back-office
    - #996: Fixed name of the guest user is not present on order detail page in back-office while guest checkout
    - #986: Fixed tax price is not calculated according to zip code in backoffice controllers
    - #963: Fixed warning in the Back-office header when update information is not available
    - #889: Fixed new hotel category gets created instead of updating previous one on hotel name update at back office
    - #856: Fixed price conversion issues while changing currency in order detail page in back office
    - #854: Fixed errors shown on order detail page in back office when booked hotel is deleted
    - #825: Fixed auto added services is not visible at back office add order and view order page
    - #822: Fixed service products are displayed when searching for room types at back office
    - #817: Fixed php warning when using non-numeric value for Position filter in renderLists at back office
    - #814: Fixed voucher of one customer can be applied to another customer at back office
    - #813: Fixed success message is not displayed for bulk status updates in a list at back office
    - #806: Fixed new cart getting created even if there are no active hotels for booking at back office Book Now page
    - #805: Fixed 'Controller not found' alert when clicking on Hotel Reservation System breadcrumb at back office
    - #803: Fixed php notice for function get_magic_quotes_gpc() on Configuration Information page at back office
    - #802: Fixed blank space displayed in Customer panel of order detail page in the back-office when customer has deleted
    - #792: Fixed warnings displayed after deleting all booked rooms from the orders detail page in back-office
    - #777: Fixed employee can search for inaccessible Service Products using search box at back office
    - #750: Fixed deleted customers are displayed when searching customer while creating a new order from back office
    - #738: Fixed Time picker not available in payment block on order detail page at back office
    - #730: Fixed PHP warning on Booking Carts > View page at back office if address of the cart customer is deleted
    - #725: Fixed Pre-populate form values after invalid form submission of hotel form at back office
    - #1270: Fixed console errors in admin room type and service form when only view permission is provided
    - #1225: Fixed javascript files are included multiple times in admin login page
    - #1150: Fixed design issue in order page and kpi when printing admin pages
    - #1143: Fixed error on AdminTranslationController while translating modules, also optimized the translation process for the modules.
    - #1128: Fixed admin is able to create account using 0 as email
    - #1120: Fixed incorrect prices show in admin refund request controller
    - #1118: Fixed admin was able to create new account using the banned account email.
    - #1114: Fixed admin cannot create different Advance price rule for different group for same date ranges
    - #1093: Fixed unable to save hotel if admin makes some fields required in address
    - #1085: Fixed issues in admin cart rule controller.
    - #1074: Fixed online column on admin Booking Carts page
    - #1069: Fixed while creating an account from the book now tab, the admin was able to select visitor and guest groups after submitting the ajax form once with errors.
    - #1056: Fixed issues if admin tries to add discount having values equals or greater to the order total or due amount.
    - #1048: Fixed the warning for invalid price shown on the Admin products controller if there is any error.
    - #1047: Fixed the modules list filter shows all modules in admin office.
    - #1044: Fixed the issues in catalog price rule (AdminSpecificPriceRuleController).
    - #1033: Fixed filter issue on Admin refund request page
    - #1019: Fixed empty copywrite year range in the footer incase the admin does not provide the website launch year.
    - #1001: Fixed should not allow admin to add rooms if order status is already canceled or refunded.
    - #1000: Fixed validation messages should be present on the view page on admin order detail page for Document Notes.
    - #995: Fixed getting a fatal error if the admin reduces(in negative amount) more from the booking than the paid amount.
    - #989: Fixed same Order ID is displayed multiple times on admin Booking Carts listing page
    - #983: Fixed number of associated room types are not shown according to hotel permission in admin service product page
    - #969: Fixed empty cart is creted when KPI visibility is updated in Admin carts page
    - #958: Fixed admin was able to update the booking dates of a room in an order to the disabled dates of that room.
    - #957: Fixed room types and service products were not displayed in the search result in the admin search controller.
    - #940: Fixed employee was able to download invoice for all hotels from Admin Invoice controller
    - #936: Fixed date selection corrections at different places in admin controllers.
    - #933: Fixed admin is able to add/update the quantity of auto added services from the AdminOrdersController, while updating any order.
    - #929: Fixed AdminOrdersRefundRequestsController showing exception to all employees except the super admin.
    - #920: Fixed super admin profile id is used instead of SuperAdmin employees ids while sending Order-Confirmation and Refund emails
    - #916: Fixed auto added services price not showing in cart summary in admin book now page
    - #913: Fixed added auto add services to the rooms added to the order by admin on edit order from the admin panel
    - #907: Fixed room reallocation process on AdminHotelRoomsBooking controller caused by space in the name of the room.
    - #893: Fixed invalid security token issue on admin Customers form page
    - #876: Fixed currency conversion in admin stats page
    - #874: Fixed incorrect forcast data in "stats Dasboard" tab in admin stats page
    - #859: Fixed admin login page opens in recommendations popup
    - #840: Fixed calendar tooltips reappear on admin book now page after adding or removing rooms from cart
    - #836: Fixed employee form language memorization (Administration > Employees) not working for some forms
    - #831: Fixed admin is unable to set empty birthday for a customer during update
    - #791: Fixed getting PS exception when admin sends `<script>` in the Message from admin order detail page
    - #790: Fixed rooms stats issue on admin Book Now page when adding or removing rooms from cart
    - #742: Fixed unable to delete room types from cart if admin visits book now page just after booking creation and before order confirmation
    - #733: Fixed admin can not set refund amount to 0 when creating refund rules
    - #723: Fixed PHP warning on Administration > Menus page when changing positions of Menus
    - #755: Fixed Social title is not displayed on Customers > Groups > View page customer list
    - #1184: Fixed Issue occurs while deleting room booking line, If there is no refund requests created for the booking
    - #1129: Fixed Dashboard issues on different sections
    - #1091: Fixed fatal error when adding negative price with an absolute numeric value equal to or less than the paid amount but a greater currency value
    - #1081: Fixed render list filter values are saved without validation
    - #1076: Fixed php warning on order detail page if all rooms from order are deleted
    - #1071: Fixed sort by price in module catelog page
    - #1053: Fixed available Fields for render list are not working if there is only one item present in the list.
    - #1029: Fixed hotel configuration options in settings only visible in default language
    - #1012: Fixed creation of two separate HotelAdvancedPayment objects for a newly created room type from two separate tabs
    - #1007: Fixed maximum occupancy, length of stay and specific prices are not duplicating correctly while duplicating a room type.
    - #1002: Fixed unable to edit the price of the room on order detail page, if price becomes with decimals more than valid limit in calculation
    - #994: Fixed unable to delete rooms from the Free order
    - #991: Fixed need to arrange the options in correct order at order list page in mobile view.
    - #982: Fixed advance price rule created during booking are visible in room type price tab
    - #976: Fixed design issue in new list header design
    - #925: Fixed multiple Advance Price Rule can be created with same conditions
    - #923: Fixed service product price and quantity was added incorrectly in order on edit/update
    - #919: Fixed issue while saving hotel with name starts with numeric values
    - #900: Fixed dashboard stats issues and also improved the view of the dashboard
    - #824: Fixed allotment Type selection in partial available rooms in book now page
    - #793: Fixed order status submitted even on clicking Cancel button while changing status from Bulk actions in orders list
    - #779: Fixed module zip validation on Module upload on Modules and Services page
    - #774: Fixed HelperForm input type 'group' submit name can not be changed
    - #764: Fixed 'Add new webservice key' button gets hidden on saving Webservice options
    - #763: Fixed Hote Reservation System tab icon breaks randomly
    - #754: Fixed 'Add a new module' button is displayed even if current employee is not allowed to install modules
    - #753: Fixed All file types are available for selection when choosing images for hotel and room type
    - #751: Fixed Groups selection is removed for Advanced Price Rule when status is changed
    - #749: Fixed Abandoned Carts filter is not working on Booking Carts page
    - #741: Fixed PHP notice on Catalog Price Rules page due to invalid input
    - #731: Fixed Filter reset button is not displayed when clicking on 'Disabled Room Types' on Manage Room Types page
    - #729: Fixed Hotel permissions are not saved when a hotel is created
    - #727: Fixed refund Rules for multiple hotels for same cancellation days can not be created
    - #1210: Fixed invalid argument supplied for foreach AdminStatsController
    - #915: Fixed translated text not visible on admin controllers

## Front Office:
- Improvements:
    - #970: Updated service product updation process on the front in the product controller
    - #844: Updated front office room type page show default date according to LOS
    - #781: Improved room search user experience at front office
    - #1201: Updated cart total summary on checkout page
    - #847: Updated page not found (Error 404) page
    - #1133: Updated original price will now be displayed with discounted amount.
    - #762: Updated search Results Page Filters options have been moved to module wkhotelfilterblock
    - #758: Updated redirect to Page not found for invalid search results page URL
    - #757: Updated redirect customer to order confirmation page after free order validation instead of order history page
    - #735: Updated open room type detail page in same tab from Our Rooms block on landing page
    - #724: Updated bankwire and cheque payment details on order confirmation page
    - #782: Updated make Our Rooms images on landing page clickable to open room type detail page
    - #959: Updated design for the our room block
    - #1017: Updated error message for guest account while transforming to customer account
    - #839: Added error message for maximum occupancy in room occupancy dropdown.
    - #1058: Added hotel rating is now visible with the hotel name on the room type page.
    - #966: Added done button in the occupancy popup in the front office.

- Bugs Fixed:
    - #1292: Fixed design issues on the order-opc page and growl notifications in RTL mode in the front-office.
    - #1263: Fixed responsive design issue in front office search block
    - #1249: Fixed translation issues and removed slashes in the error message from cart validation process in the front-office.
    - #1242: Fixed the default date ranges in the booking form are not correct in case los and minimum booking offset is applied on the room type in the front-office.
    - #1236: Fixed cart rule without code is not being applied automatically to the cart in the front-office.
    - #1234: Fixed the price breakdown was incorrect with tax when a voucher was applied to an order, affecting invoices, emails, front-office, and back-office displays.
    - #1179: Fixed the price tooltip and updated the design for the booked services and demands popup on the order confirmation page in front office.
    - #1171: Fixed the RTL languages design issues on the front office.
    - #1144: Fixed the design for the 'Subscribe' button on the order-detail page in front-office
    - #1113: Fixed no validation for length of characters in traveller detail fields in Front and Back office
    - #1020: Fixed a room type shows multiple times in customer message section in front office order detail if admin adds a room from back office.
    - #1013: Fixed notice on room type page in the front office caused by selecting 'no tax' as a tax rule option.
    - #934: Fixed if advance price rule discount is applied on a room type having auto add service with "Add price in room price", discounted price is not displayed on room block section in front office.
    - #924: Fixed incorrect room price and final price when admin remove service product or update room price from admin end and proceed for payment at front office
    - #860: Fixed front office 'hotel-reservation-theme' RTL compatibility
    - #849: Fixed security Vulnerability: XSS for back and email_create parameters while registration in front office
    - #838: Fixed services image legend not visible on front office room type page
    - #834: Fixed buttons positioning issue on search results page at front office due to long length of button texts in certain languages
    - #816: Fixed customer is logged in automatically after password reset at front office
    - #795: Fixed 'Add Room' button is displayed on occupancy popup even if no more rooms are available at front office
    - #788: Fixed error when updating address from customer acccount which has been used to create an order at front office
    - #786: Fixed php warning on removing room from cart dropdown at front office
    - #785: Fixed custom price set for a room type in an order at back office is also reflected at front office for same customer
    - #737: Fixed voucher description usage in front office
    - #1272: Fixed order confirmation and Guest tracking flow issues and order emails are improved
    - #1086: Fixed the customer messages sent from the contact page updates the previous message even if the subject (contact) selected is different.
    - #988: Fixed unable to send customer request mail from contact us page
    - #981: Fixed wrong voucher amount in different currencies on customer my vouchers page
    - #740: Fixed customer/Guest account form on checkout page is not submitting on pressing Enter key
    - #1089: Fixed error on order confirmation page when order status is updated
    - #977: Fixed search panel issue on room type page when hotel is disabled
    - #968: Fixed display issue with the amenity block in page load/reload in the home page
    - #917: Fixed order currency symbol changes on currency change event on order confirmation page.
    - #886: Fixed if amenities are not present then amenity filter at search results page should not be visible
    - #845: Fixed address issue on voucher deletion from cart dropdown on checkout page
    - #800: Fixed wrong Amenities block height on landing page in mobile view
    - #787: Fixed if searched order reference has multiple orders then same rooms are displayed for each order on guest history page
    - #773: Fixed PHP warning for key 'id_country' on search results page
    - #772: Fixed phone number can not be edited during guest checkout
    - #746: Fixed PHP warning due to occupancy query parameter in URL when generating canonical redirect URL

## Core:
- Improvements:
    - #1142: Optimized the flow of the blocknewsletter module
    - #1194: Updated optimized dataForFrontSearch function
    - #1217: Added changes in core algo for managing booking for hourly basis
    - #1173: Updated the Meta data for the index page on install, and also updated some non translated text for some languages.
    - #1021: Improvement in the block navigation link module regarding CMS pages.
    - #960: Updated installation page design changes.
    - #1200: Updated price Rounding process improved in entire QloApps system
    - #1174: Updated helper tree | Created a new helper tree class for generating tree
    - #1161: Updated id_address_delivery is now set as 0 by default
    - #1156: Updated the demo data added to the database for the QloApps on installation.
    - #1141: Updated default invoice will be shown even in case of b2b invoice
    - #1140: Updated the hero image and its upload process.
    - #1111: Updated installation Assistant translations
    - #1109: Updated decimal digits maximum limit is removed from price validation by Validate::isPrice()
    - #1098: Updated validations for the occupancy of the room type for max occupancy of guest
    - #1084: The google maps will now display the map icon for the hotel locations.
    - #1079: Updated positions of Installer Assistant footer buttons
    - #951: Added values for columns 'price_calculation_method' and 'price_addition_type' for demo service products.
    - #1062: Updated htaccess files comptible with apache 2.2 and 2.4
    - #1040: Updated Qloapps cleaner | Added hook for data cleaning in other module and fixed incorrect data being deleted.
    - #972: Improved Algo for response data and format
    - #950: Updated get localization pack details from qloapps api
    - #949: Updated version request while downloading language pack
    - #892: Updated use different prefixes for demo room numbers belonging to different room types
    - #885: Updated address country of demo customer 'pub@qloapps.com' changed to website default country
    - #871: Updated tax of room type will be applied to auto add services having price added to room price
    - #842: Updated invoice tax panel content
    - #862: Updated order cancelation successful mail content
    - #861: Updated when translating text in QloApps only update the fields that are changed
    - #858: Updated recommendation section update process
    - #768: Updated change cookie key prefix to QloApps
    - #783: Updated do not create multiple guest acounts with the same email, use previous one if available
    - #780: Updated replace 'shop' and 'shopping' with 'website' and 'booking' in email templates
    - #778: Updated add India to top countries in list of countries during installation
    - #759: Updated function call corrected for room type price calculations
    - #1221: Reuse existing HotelBookingDetail instance to avoid redundant object creation
    - #1005: Renamed Partial payment accepted to Partial payment received.
    - #908: Improved Order Status changes, Refund issues resolved and order and cancellation process improved
    - #823: Updated text changes
    - #821: Removed Password field from new account email sent to customer on registration
    - #810: Updated Use datepicker plugin to format dates using $.datepicker.parseDate() wherever applicable
    - #804: Updated flow of blocknewsletter module
    - #744: Updated set default customer group to Customer when transforming Guest account
    - #1193: Updated hr.xml
    - #1131: Removed non required emails from the order status template list
    - #728: Removed unused module folders from themes/hotel-reservation-theme/

- Bugs Fixed:
    - #717: Fixed DataForFrontSearch to dataForFrontSearch
    - #1260: Fixed jquery chosen, select and tinymce plugins used images not visible in different admin theme
    - #1255: Fixed Localization pack not updating from correct resource during QloApps installation
    - #1253: Fixed admin is able to select empty country during QloApps installation
    - #1250: Fixed Categories for demo service products are not created correctly on installation.
    - #1148: Fixed welcome voucher is available for every customer and also for guest user
    - #1090: Fixed cart rule restricted to a single customer is accessable to all customer when group restriction is applied
    - #867: Fixed when customer age is not available then it is considered 60+ age as default
    - #820: Fixed errors set from hook 'actionBeforeAuthentication' are not checked before logging in a customer
    - #765: Fixed same voucher code is generated for same customer when auto-generating voucher
    - #1205: Fixed the undefined variable issue in payment module.
    - #1203: Fixed invalid auto-added service prices when multiple rooms are added in cart or service is disabled or removed from catalog.
    - #1202: Fixed service not visible in booking when service is deleted from catalog after order
    - #1190: Fixed trying to access array offset on value of type bool in cacheMainDomainForShop() in ShopUrl.php
    - #1162: Fixed hotel permission are not being created for new hotels.
    - #1153: Fixed partial cart rule not creating when using multiple coupons in a single cart
    - #1147: Fixed unable to find correct files for translating pdf and mail files
    - #1136: Fixed cancelled room service is visible when same room is added again in order
    - #1107: Fixed cookie not saving in browser when '+', '&', ')', '(' characters exists in Base URL
    - #1104: Fixed order-opc page not opening when installed QloApps in Čeština (Czech) language
    - #1100: Fixed calendar opens for pervious month of max order date is for current month
    - #1097: Fixed issues in Refund management flow and Improved Order cancellation flow
    - #1095: Fixed multiple coupons gets removed from cart when currency is changed
    - #1054: Fixed when Order status set as cancelled the rooms are not set is_cancelled=1 in the htl_booking_detail table
    - #1027: Fixed cart rule does not show under available coupons when cart rule is created from refund request
    - #1018: Fixed notices and display issue when there is no rooms and no hotel available.
    - #964: Fixed room type categories were not updated when hotel name or location is updated
    - #945: Fixed data changes are not reflected when using the QloApps cache option
    - #931: Fixed js issue due to map if Google Maps API key is set and hotel location is not set
    - #921: Fixed pricing issue in order confirmation email
    - #909: Fixed missing translation from the templates of the modules.
    - #906: Fixed when no tax is applies on room extra services, service tax column is shown empty in invoice
    - #903: Fixed smarty index.php in smarty cache and compile directory gets deleted when clearing cache
    - #895: Fixed overbooking issues in QloApps and added new configurations for overbooking handling
    - #872: Fixed invalid tax details in invoice and credit slips
    - #857: Fixed exception while order crteation when country sent from API is not active in QloApps
    - #848: Fixed wrong prices entered in order_detail table when "Round Type" setting is "Round on each item"
    - #843: Fixed friendly URL for search results page can not be changed
    - #1181: Fixed missing error message for OpenSSL extension during install system check step
    - #756: Fixed cancellation charge amount is incorrect if order currency is other than default currency
    - #752: Fixed file '/cache/smarty/compile/index.php' gets deleted when clearing cache causing warning on Configuration Information page
    - #745: Fixed link::getMediaLink() not used for invoice logo
    - #734: Fixed new voucher does not create for the remaining amount of the voucher even when Partial Use option is enabled
    - #732: Fixed Fatal error: Uncaught Error: Class 'HTMLPurifier_Config' not found when enabling HTMLPurifier library
    - #1220: Fixed apple-mobile-web-app-capable deprecated
    - #722: Fixed Fatal error when set Awaiting Payment order status as logable and creating partial payment

## Web Services:
- Improvement:
    - #1198: Optimized Hotel Room Type Availability and rates search webservice
    - #1247: Added Phone number field in the customer API.

- Bugs Fixed:
    - #1175: Fixed issues in the Webservices.
    - #855: Fixed issues in getting(GET), creating(POST) and updating(PUT) hotel by hotel API
    - #720: Fixed issues in response of Availability & Rates search API for partial available rooms


####################################
# V1.6.0
####################################

- Added Features:
  - #538: Added Feature service products
  - #516: Added "Channel Manager Connector" module to QloApps
  - #643: Add module Dashboard Insights to admin dashboard
  - #475: Added occupancy wise search and occupancy wise booking
  - #449: Added Modules catalog page
  - #370: Added PayPal Payment in QloApps
  - #370: Added Autoupgrade addon: Upgrade QloApps to latest available version
  - #463: Add 'Operations Today' section on admin dashboard
  - #435: Minimum and Maximum Length of stay restriction for room types
  - #449: Added smart addons recomendation section
  - #531: Admin can upload check-in documents
  - #456: Admin can add or remove new links on Hotel Reservation System > Settings page
  - #343: Employee can access the site in maintenance mode
  - #459: Security update: Allow admin to configure the SameSite cookie attribute
  - #589: Added cancellation policy section on admin order view page
  - #479: Added preparation time for bookings
  - #454: Customer can now create booking for someone else.
  - #593: Guest transformation to customer during registration at front office
  - #490: Added "Hotel Availability and Rates search API" to QloApps
  - #375: QloApps can now be installed without demo data


- Back Office:
  - Improvements:
    - #351: Add hotel address selection on map using marker at back office
    - #449: updated dashboard
    - #337: Removed delivery column and added full name to customer column on order list page at back office
    - #345: Add room type duplication feature
    - #346: Remove unused room status from room type edit page
    - #347: Improve back office logos
    - #354: Remove Google Maps api from order detail page at back office
    - #355: Added upper limit of PHP for QloApps installation
    - #357: Remove module config links from Hotel Reservation System > Settings page
    - #376: Remove global price option when not needed from additional facilities…
    - #380: Add error messages for missing tests on Configuration Information page
    - #383: Remove Catalog > Tags page and Tags field from room type edit page
    - #388: Removed unused field minimum quantity from Specific price
    - #395: Load KPIs data using ajax on page load at back office
    - #405: "BO: Fix datepicker issues, calendar improvement and update admin theme sass files
    - #409: Change Feature Price name to Advanced Price Rule
    - #423: Improvement: Booking carts controller in Back-office
    - #451: Improve statistics at back office
    - #453: Remove Booking Information tab from room type edit page at back office
    - #453: Remove Booking Information tab from room type edit page at back office
    - #464: Implement Additional Facilities tab in AdminProductsController instead of using hotelreservationsystem module hook
    - #471: Move filter options to Preferences > Room Types page
    - #478: Update admin book now page design | added fullcalender
    - #485: Update default checkout date on order view page at back office
    - #509: Added: SQL_MODE for allow invalid dates in db backup
    - #515: Optimize: Module suggestion listing process
    - #522: Updated: Book now page calender view
    - #526: Update refund option and orders state mangement
    - #551: Updated best selling rooms and most viewed rooms statistics
    - #555: Removed: unused category KPIs
    - #563: Change Geolocation data file link at back office
    - #571: Remove Order Restrict link from Hotel Reservation System > Settings page
    - #580: Updated: removed unused configuration options from admin catagory tab
    - #581: "Updated admin service product configuration in SEO, Prices and association tabs
    - #582: Removed selected extra services list from current cart in backoffice book now
    - #586: Update Dashavailability graph
    - #594: Remove unused fields from Catalog Price rule
    - #607: Updated: Service products pop-up modal in admin order view page
    - #611: Updated: added complete booking info in admin booking carts tab
    - #623: Added: access restriction according to hotel in admin search page
    - #629: Enable custom handler for backoffice.
    - #632: Update disable dates selection for a room at back office
    - #633: Update hotel review view page at back office
    - #639: Update refund request view page at back office
    - #653: Updated: Additional facilities panel in admin room type page
    - #655: Updated: compiled admin theme css from sass
    - #674: Add label for Length of Stay graph on dashboard
    - #678: Removed: "go to payment page" option from admin order create page when creating order for backdate
    - #535: Added : autocomplete parameter to date and datetime options in admin render form
    - #429: Price modification while new order creation at back office
    - #696: Updated: Manage room type default configuration and advance payment form options
    - #697: Removed: In the manage category page removed description column from list
    - #704: Updated: Data in admin refund request, corrected data in rooms refund detail table.

  - Bugs Fixed:
    - #314: Resolve HelperList filter issue
    - #340: Resolved a fatal error when forwarding a discussion to another employee on the Customer Service page.
    - #358: Resolve order total invoice issue on backoffice orders page.
    - #359: Resolve 'Revenue' amount issue on admin dashboard
    - #360: Resolve specific price list issue on room type edit page
    - #361: Correct outgoing search links on search page at back office
    - #368: Resolved issue when preview template in backoffice order status page
    - #369: Resolved customer thread not forwarding to another employee from backoffice customer service
    - #378: Fix ConfigurationKPI values issue when adding a new language
    - #379: Fix controller access denied page design
    - #382: Resolve undefined index issue on Order Restrict update form
    - #389: Prevent Admin or employee from adding rooms in order other than rooms of current hotel in order
    - #391: Updated dashboard structure | Fixed dashboard widget
    - #396: Fix PHP notice issue when accessing unavailable objects on admin controller
    - #407: Fix loading of unnecessary media files on Manage Room Types page
    - #408: Fix tpl path issue on Manage Room Types page
    - #411: Fix admin login page design issue
    - #412: Resolve dashboard design issues
    - #413: Fix date formats at back office
    - #421: Fix rooms addition to a room type issues at back office
    - #428: Fix PHP notice issue for key `stage_name` on order view page at back office
    - #434: Fix employee avatar not showing at back office
    - #439: Fix module reset options popup issue on Modules & Services page
    - #444: Fix undefined variable issue at Hotel Interior Block settings page at back office
    - #455: Fix Book Now page at back office
    - #461: Fix currency update issue on order creation page at back office
    - #466: Resolve issue when total order paid amont is in negative
    - #473: Fix database exception issue on Book Now page at back office when multiple QloApps installations are present on the same domain
    - #481: Fixes module not installing from new catalog page
    - #486: Fix undefined variable issue on admin dashboard
    - #495: Added: missing re-allocation pop-up and improved design in book now page
    - #496: Fix warning when tab_modules_list is empty
    - #502: Fix Division by zero
    - #510: escape: unsupported type: UTF-8 - returning unmodified string
    - #513: Fixed Undefined property: $toolbar_btn
    - #523: Fixed: incorrect payment amount adding from addOrderPaymentDetail
    - #525: Fixed: Download module error showing when checking for update on manage module page
    - #537: Fix bug in order refund request process at front office
    - #540: Fixed: totalAvailableRooms warning issue resolved on room detail page
    - #542: Resolved: advance price rules validation issue
    - #544: Resolved: bad sql query issue when assigning features to the hotel
    - #547: Resolved: Db exception on qlocleaner integrity check
    - #549: Resolved: issue on free order and room reallocation
    - #554: Resolved: room status update issue from active to inactive.
    - #554: Resolved: room status update issue from active to inactive.
    - #560: Fix guests count in Operations Today panel of Dashboard
    - #564: Fix Stats > Stats page issues
    - #565: Fix incorrect value of Purchased References KPI
    - #566: Fix Unknown customer age on Stats > Stats page
    - #567: Fix Direct Revenue Ratio (DRR) on dashboard
    - #568: Fix room add/edit issue on order from back office
    - #573: Change catalog evaluation module and fix stats issues
    - #574: Fix: Services price not including in cancelation charges.
    - #575: Resolved: Issue while adding room in order for deleted customer
    - #577: Resolved: Backoffice ajax loader does not stop after closing dashboard recommendation
    - #578: Fix Customers KPI on Customers page
    - #579: Resolved: Exception on admin book now page after cleaning cart data
    - #587: Update guests count in Operations Today on dashboard
    - #588: Resolved: Issue while exporting service products and booking carts
    - #591: Fix can not create order from Customers > Booking Carts page
    - #597: Fix filter issues on Assign Hotel Features page at back office
    - #599: Fix js errors on admin book now page
    - #602: Fix Add new buttons display issue at back office
    - #612: Resolved: hotel tagline and short description wrong format
    - #616: Resolved: Mulitple hotel cover image created when uploading multiple images
    - #625: Fixed: book now page calender does not show searched date month
    - #628: Fixed: Inconsistent price for facilitiy in room row and pop-up modal in admin orders view page
    - #640: Fix order room dates edit issue at back office
    - #641: Fix ajax error on login page at front office
    - #642: Fix: Admin is able to add rooms in order without selecting occupancy
    - #647: Fix order creation without address at back office
    - #662: Fix: Module update error when uploading zip without db changes
    - #666: Fixed: backoffice header toolbar buttons not visible on some pages
    - #667: Fix: Syntax issus on admin import page.
    - #670: Updated: Admin room type services and facilities panel text issues and undefined index issue
    - #671: Fix dashinsights comparison graphs issue
    - #675: Fix Average Occupancy Rate issue on dashboard
    - #676: Fix 'Best hotels' and 'Best-selling room types' issues on Stats > Stats page
    - #681: Fixed: Incorrect price of room when admin adds room in order and room have auto add services
    - #694: Resolve: errors while adding new hotel
    - #695: Fixed: dashboard  graphs errors when data set is empty
    - #701: Resolve: Address not updating on admin address and order page.


- Front Office:
  - Improvements:
    - #336: Remove order history link for guest account holders on order confirmation page
    - #367: Updated meta generator tag to QloApps
    - #377: Add check-in and check-out time on room type detail page
    - #385: Improve front office header
    - #387: Add nav bar and move language and currency selector at top at front office
    - #400: Updated booking form on room type detail page
    - #403: Add maps to search results and room type detail pages
    - #410: Add hotel images under room information on room type detail page
    - #474: Remove unwanted js and fix room search issues on room type detail page
    - #484: Reviews module: Show updated helpful count when marking a review helpful
    - #505: Updated tax view in cart popup
    - #536: Remove address deletion code from front office
    - #545: Added: check in - check out label on room type page
    - #548: Updated search result page booking option view
    - #550: Updated QloApps search panel design
    - #596: Remove refund ID column on refunds list page at front office
    - #624: Fix: Dropdown displaces on search result page when adding children in room
    - #630: Update navigation menu at front office
    - #631: Added: Missing vat number field in customer address form.
    - #634: Show room maximum occupancy on search and room type page
    - #635: Update: datepicker dates background color for dates between date-from and date-to
    - #664: Improved occupancy dropdown on search result page
    - #682: Updated: order summary in block cart popup and dropdown
    - #687: Add default contact phone and email at front office nav bar
    - #698: Fixed: occupancy dropdown input not alligned with adjacent input
    - #699: Fix: service product quantity getting updated incorrectly from order OPC page
    - #705: Replaced: view voucher and credit slip button with voucher code and id credit slip
    - #706: Added: address update success message

  - Bugs Fixed:
    - #348: Resolve auto page scroll issue on order history page
    - #362: Resolve room type name font issue at room type detail page
    - #373: Fix wrong search results page url causing SQL error
    - #390: Resolve rooms left count issue on cart update on room type detail page
    - #397: Fix PHP notice issue on room type detail page
    - #414: Fix guest can not edit personal info on checkout page issue
    - #417: Resolved address issue on contact page for list and map
    - #419: Fix hero image cache issue
    - #482: Fix PHP error on passing wrong dates in URL
    - #483: Resolved: logo visible bigger than recomended size in default theme
    - #504: Fix ajax page not found issue on room type detail page
    - #518: Fixed: User input in location field in search panel get replaced by hotel location
    - #541: Resolved: hotel image issue on room type page
    - #552: Resolved: guest order detail page issue
    - #553: Resolved: PHP warnings on the refund request
    - #556: Resolved: service product url issue
    - #558: Fix order cancel request issue
    - #570: Fix maps issue on room type detail page
    - #576: Fix cart rule applied icon issue on checkout page
    - #598: Fix PHP issue on front pages
    - #603: Fix children age selection error with occupancy booking at front office
    - #605: Resolved: Service producs all images not visible in front office
    - #606: Updated: Hide service product prices in catalog mode.
    - #615: Resolved: Order restrict error is displayed multiple time on checkout page
    - #617: Resolved: unable to create refund request
    - #626: Fixes: Unable to view or save customer address from front office
    - #638: Close occupancy dropdown on clicking book now button
    - #649: Fix: Occupancy panel does not close when clicking on add to cart button
    - #651: Fix: imgaes index not defined for services on room type page in front office
    - #652: Fix: Booking form does not get update when occupancy is not provided
    - #654: Fix: Booking form refresh when occupancy dropdown is opened
    - #663: Fixed: Errors on guest tracking page
    - #668: Fixed: Error on search result page when updating invalid occupancy in URL
    - #672: Updated: Disable option to add services when rooms are unavailable
    - #677: Fix image display issue on homepage
    - #679: Resolved: Error on landing page when updating page view count using data mining module
    - #680: Fixed: Datepicker not initializing on initial load of room type page with preperation time
    - #683: Updated: Fixed chekcout page auto add service breakdown tooltip incorrect content
    - #685: Update default number of rooms on room type detail page to 1
    - #700: Fix: quantity does not change on room type page booking form
    - #703: Resolved: booking details message block issue


- Core
  - Improvements
    - #372: Add hooks actionSubmitIdentityBefore and displayCartRoomImageAfter
    - #418: Add hooks displayAdminAddHotelFormTab and displayAdminAddHotelFormTabContent
    - #332: Updated demo link in readme file
    - #334: Remove install.sql files from modules
    - #338: Replace booking type integer values with class constants
    - #353: Remove smarty modifiers json_encode and json_decode | change in deprecation message
    - #356: "Moved hotelreservationsystem ""actionvalidateorder"" to core function ""validateorder""
    - #364: Remove theme 'default-bootstrap'
    - #365: "Update Readme - PHP, MySQL and Required PHP extenstions
    - #366: Updated core upgrade files and modules upgrade files
    - #371: "Updated tax flow, Taxes are now calculated based on hotel address
    - #381: Change demo city name from DefCity to Demo City
    - #401: Remove unused modules
    - #402: Change module category for modules graphnvd3 and hotelreservationsystem
    - #404: Update PaymentModule.php
    - #415: Removed qlo_mod_list.xml
    - #420: Remove unused code and data from module hotelreservationsystem
    - #426: Replace _PS_MODULE_DIR_ with $this->_path in 'wkroomsearchblock' module
    - #430: Updated QloApps order statuses
    - #432: Updated Language pack resource will be downloaded from QloApps
    - #443: Remove Google+ URL from blocksocial module
    - #447: Improvement of cart rule applied on orders and room types
    - #458: Replace module 'productcomments' with 'qlohotelreview'
    - #460: Remove characters limit of 128 for hotel fields 'map_formated_address' and 'map_input_text'
    - #467: Removed multiple address option
    - #468: Update image generation method for hotel and default modules
    - #469: Enable Re-display cart at login by default
    - #476: Use object methods save() and delete() for classes HotelCartBookingData and HotelBookingDetail
    - #477: Update api endpoint and request data
    - #500: Improve order refund flow
    - #519: Improved: Enable ssl configuration during installation
    - #521: Updated occupancy dropdown
    - #527: Fix CLI install issues
    - #528: Update licenses
    - #532: Change demo content for CMS page Legal Notice
    - #657: Allow checkout process classes to be overridden
    - #669: Updated: text translations call variable assigned to javascript
    - #688: Update CONTRIBUTING.md
    - #689: Update SECURITY.md
    - #690: Update README.md
    - #431: Added gitignore file
    - #692: Updated: Recomendation section update and render process
    - #342, #363, #436, #462, #470, #480, #543, #546, #561, #562, #569, #595, #618, #644, #658, #673, #686: Text related changes throughout QloApps

  - Bugs Fixed
    - #329: PHP Version issue in Install of QloApps 1.5.2
    - #394: Fix hotel city access method as introduced in tax flow changes
    - #416: Resolved wrong address while creating new booking
    - #425: Fix owl-carousel plugin loading issue for 'wktestimonialblock' module
    - #433: Fix Webservice count() issue
    - #438: Fix page scroll issues at order history and order view page
    - #448: Resolve multiple hotel room booking from single cart
    - #452: Fixed: count() function use issue in WebserviceOutputJSON.php
    - #514: Resolve: Occupancy wise search feature issues
    - #520: Fix order confirmation email issue
    - #534: Fix installation issue of missing data
    - #557: Fix js minification issue for file 'js/daterangepicker/moment.min.js'
    - #559: Change link in credit slip email
    - #583: Resolved: Unable to add room in cart from front and backoffice
    - #584: Resolve: Inactive auto add service price still gets added to room price
    - #585: Updated: depricated call for array_key_exists to property_exists for object
    - #592: Resolved: Incorrect advance payment amount when discount is greater than advance payment
    - #604: Resolved: service products can still be added multiple times when configuration is disbled
    - #608: Fix: Unable to remove disabled services from cart
    - #609: Resolved: Cannot create booking with srevice produsts in cart
    - #610: Resolved: price not defined of service product when multiple rooms are bought in order detail page
    - #614: Resolved: Specific price does not apply base on priority
    - #621: Resolved: Catalog discount is not visible when auto add service is attached to room type
    - #627: Fixed: Order summary in order confirmation page and order confirmation e-mail
    - #659: Prevent required categories deletion by data cleaner module
    - #660: Fix: cover image index not defined while generating invoice
    - #665: Fix: Qlocleaner "fix integrity constraint" deletes valid additional facilites
    - #684: Fix PHP warning issue in catalog mode
    - #645: Added: checkoutProcess directory in override/classes
    - #693: Fix: hotel not getting added in hotel profile access table
    - #702: Update: Order invoice pdf, changed totals summary details.
    - #715: Fix PHP warning on order checkout page at front office


- Web Services:
    - Improvement:
      - #529: Fixed: API issues in order creation from webservice request

    - Bugs Fixed:
      - #517: Fixed: Incorrect id_guest in cookie after login
      - #452: Fixed: count() function use issue in WebserviceOutputJSON.php


####################################
# V1.5.2
####################################

## Added Features:
- #264: Added SECURITY.md file.
- #313: Update for module upgrade and suggestion


## Improvements:
- core
  - #240: Updated TCPDF library
  - #242: Changes for PHP7 compatibility
  - #243: Removed pclzip library
  - #244: Removed pear JSON lib instead use PHP JSON library
  - #245: Updated swift mailer
  - #246: Updated htmlpurifier
  - #247: Updated Smarty library
  - #249: Updated Sql Parser Library
  - #250: Updated Pear and Archive tar library
  - #267: Removed mysql support, pdomysql now required
  - #269: Replaced mcrypt with openssl
  - #272: Changed default DB prefix to qlo_
  - #276: Paypal and PaypalUSA module removed
  - #290: Updated path for including css and js in modules | Moved plugins to core js folder
  - #299: Added composer.json file

- Front Office:
  - #296: Improved Social Sharing module
  - #316: Display Room Capacity on room type detail page

- Back Office
  - #297: Changed import button icon on Localization page
  - #310: Dashboard improvement
  - #327: Resolved QloApps dashboard issues


## Bug Fixed:
- core:
  - #238: Update date format in invoice according to format provided in language
  - #253: Using room status as constants instead in values
  - #270: Using room availability status as constants instead in values
  - #273: Fixed date format for additional facilities in invoice
  - #281: Resolved smarty html comments issue.
  - #283: Invalid value inserted in 'special_days' field in htl_room_type_feature_pricing table through API
  - #284: Resolved: No validation for the fields in 'hotel_refund_rules' API for add and update.
  - #285: Resolved: No validation for the fields in 'hotel_features' API for add and update
  - #286: Validations added for 'password' and 'email' fields for the 'employees' API.
  - #287: Resolved fatal error while generating class index file
  - #288: Resolved: No validation for field 'id_parent in' in 'categories' API.
  - #289: Validations added to the fields of "bookings" API for POST / PUT API requests
  - #307: Cart and Order API Issues resolved
  - #312: Text issues solved
  - #321: Fixed QloApps installation issues
  - #324: Resolved compatibility issue with php5.6

- Back Office:
  - #255: Fixed filter by Due amount results in "Bad SQL query"
  - #259: Fixed room reallocation availability list for temporary unavailable rooms
  - #256: Fixed Swap rooms leads to reservations duplications
  - #251: Removed unused options from images controller
  - #271: Fixed syntax issue in admin information cont
  - #275: Resolve order total update issue on additional facilities update
  - #282: Order refund states 'Refunded' and 'Denied' should not enabled together from render list
  - #293: Add profile access restriction when adding room types
  - #294: Resolve order edit issues, Added hooks in order edit process
  - #303: In 'Manage Hotel' Controller, validation added for 'check-out time must be before check in'
  - #304, #315: Text change.
  - #318: Resolve multiple rooms addition issue on AdminOrdersController
  - #320: Resolved new room features automatically mapping to all the room types

- Front Office:
  - #252: Update function getRoomBookingData
  - #268: Update blockrss module
  - #277: In _DB_PREFIX__orders table column advance_paid_amount value is wrong
  - #280: Wrong amount displayed in Order confirmation page in the payment gateways PaymentReturn Hook
  - #291: Resolved: Wrong price return by advance payment functions in HotelAdvancedPayment class
  - #295: Resolve DNI field issue during guest checkout
  - #298, #274: QloApps text changes
  - #300: Room amenities name shown with feature icon in room type details page
  - #301: Unused CSS file htl-reservation-general.css and its classes are removed
  - #302: Resolved: On translating page checking and checkout dates are changed to NaN-NaN-NaN
  - #305: Resolve tab design issue on room type detail page
  - #317: Resolve jQZoom issue on room type detail page
  - #319: Resolved smarty minify HTML issue


####################################
# V1.5.1
####################################

## Added Features:
- Core:
  - #208: "Catalog Mode" option added by which user can view room details but not abe to create booking


## Improvements:
- Back Office:
  - #206: Removed Other Modules setting from admin Hotel Reservation System -> Settings
  - #200: Removed shipping option from car rule condition.
  - #199: Removed "Display suppliers and manufacturers" and "Display best sellers" options from Admin Preferences controller
  - #193: Removed Payment Modules setting from admin Hotel Reservation System -> Settings
  - #189: Moved hotel selection from configuration tab to information tab
  - #179: Added hotel column in room type feature pricing list
  - #177: Removed multishop option
  - #149: Removed carrier column from Booking Carts Controller
  - #183: Added hotel name along with room name when adding filter of room type for cart rule
  - #204, #196, #182: Text Changes
  - #110, #111: Code Optimization

- Core:
  - #223: getHotelCartBookingData() : function multiplication optimized
  - #225: HotelRoomTypeFeaturePricing.php optimized (Removed unused variables, removed static values assigned)
  - #218: Added hotel name column in order confirmation mail and invoice.
  - #210: CMS page Delivery is not valid for hotel industry. So changed it to Policies page
  - #205: Prevent deleting profile which is used by at least one employee
  - #214: blockcart module :: Removed unused hooks displayLeftColumn and displayrightColumn
  - #180: license file name changed from LICENSES to LICENSE
  - #181: Readme file improvements with more information and links
  - #221: dataforfrontsearch() function now calculate and provide "feature_price_diff" value in response
  - #175: Changed QloApps versioning system (Ex: X.X.X.X)
  - #175: Updated module compatibility check with QloApps version
  - #215: "hotelreservationsystem.php" code optimization in hook "actionValidateOrder"
  - #117, #118, #119, #120, #121, #122, #134, #137, #138, #139: Changes for PHP7 compatibility
  - #178: Text Changes
  - #198, #226: Multiple hooks are added in the different QloApps core files
  - #217: `auto_generated` column in `address` table added to track address creation source
  - #207: New order states 'Partial payment accepted' and 'Awaiting partial payment' added for the partial payment

- Front Office:
  - #222: Disabled mobile keyboard pop up when using date-picker in home search
  - #208: Room type listing on search result page moved to different template "room_type_listing.tpl"
  - #185: Replaced star rating plugin with jquery Raty in Product Comments module
  - #156: "product.js" code multiplication optimized
  - #215: "ajax-cart.js" add validation
  - #125, #127, #141, #142: Changes for PHP7 compatibility
  - #187: Display voucher name along with voucher code on order page


## Bug Fixed:
- Back Office:
  - #211: Errors on cart rule page when add room type, which is not assigned to hotel, selected in room type condition
  - #197: wrong theme information is displayed at Preferences -> Themes admin controller
  - #195: Filter by position in the render lists of admin controllers
  - #194: Entering wrong discount while Group creation, page redirects to list page
  - #192: Using filter in customer Group list, page redirects to previous list
  - #189: Room Type associations with its hotel parent category
  - #176: Birthday input field width in Helper Form
  - #173: Undefined varaible issue Manage Order Refund Request Controller
  - #171: Multiple request on single click in Helper List
  - #160: "Access Denied" issue when an employee other than super admin create a new room.
  - #168: Room number not updating after room reallocation and swap
  - #162: Additional facility price changes for room type after saving
  - #147: Creating order status without entering "status name", page redirects to blank page
  - #148: Creating order refund status without entering "status name", page redirects to list page
  - #229: Resolved undefined variable error in Manage Order Refund Request Controller

- Front Office:
  - #212: Design issue of select in the ADDITIONAL FACILITIES if text exceeds from block in the product detail page
  - #209: Errors on the search result page: If new group is created and only this group is assigned to the customer
  - #203: Guest is unable to submit Refund Request again after entering invalid Refund Reason once
  - #158: Hotel selection in search panel for mobile devices
  - #169: Wrong price displayed when booking from 1 march to 30 march
  - #151: Room search check-in && check-out don't change when friendly URL is disabled.

- Core:
  - #186: Links in mail for my-account, guest tracking and my orders pages are now localized to customer language.
  - #109: updated invalid varaible "pshone_mobile" to "phone_mobile"
  - #202: "global.css" added missing class for aligning images left and right in discription


####################################
# V1.5.0
####################################

## Added Features:

[+] CO : QloApps APIs are created (Prestashop APIs are modified as per hotel QloApps changes)
[+] CO : `is_advance_payment` column is added in the 'cart' table.
[+] CO : `is_advance_payment`, `advance_paid_amount` columns are added in the 'orders' table.
[+] CO : `id_transaction`, `payment_mode`, `refunded_amount`, `by_admin` columns are added in the 'order_return' table.
[+] CO : `id_order_return_detail`, `id_htl_booking`, `refunded_amount` columns are added in the 'order_return_detail' table.
[+] CO : `send_email_to_customer`, `send_email_to_superadmin`, `send_email_to_employee`, `send_email_to_hotelier`, denied`, `refunded`, `module_name` columns are added in the 'order_return_state' table.
[+] CO : `customer_template`, `admin_template` columns are added in the 'order_return_state_lang' table.
[+] CO : `id_htl_booking` column is added in the 'order_slip_detail' table.
[+] CO : Refund emails will be sent to the customer as per return state setting
[+] CO : All images link are now generated dynamically

[+] FO : Room type refund policies in the policies tab is shown in the room type details page.
[+] FO : A controller will be there for the customer which will show his refund requests info

[+] BO : Admin can enable/disable refund for the hotel
[+] BO : Refund Process:: Order return statuses improved for order refund statuses.
[+] BO : Admin can select rules for the hotel [checkboxes]
[+] BO : Admin can initiate refund if refund is enable for the system
[+] BO : Admin can select which state is considered as refunded complete in the return state.
[+] BO : Admin can select which state is considered as refunded denied in the return state.
[+] BO : Admin can select whcih email will be sent to customer and admin for the return state.

[+] BO : Feature Price Rule: Groups wise Condition in feature price rules is added.
[+] BO : Global refund policies cms page can be selected from refund rules controller.
[+] BO : Refund can be enabled/disabled globally from refund rules controller.
[+] BO : Payment mode and transaction id can be saved for the refund.
[+] BO : Voucher slip can be generated for refund.
[+] BO : Credit slip can be generated for refund.
[+] BO : Additional facilities can be edited at the time of order editing.
[+] BO : Room type features images are used as jpg images in place of png images.


## Improved/changed features:

[*] BO : Refund Process:: Order return statuses improved for order refund statuses.
[*] BO : In Additional Facilities list no price will be shown if facility have advance options.
[*] BO : Admin will be able to select a checkout date while changing status of the room from order details page.
[*] BO : Hotel category will be selected Default room type category.
[*] BO : In Room type renderlist hotel(instead of category), city, number rooms, adults, Childs columns added.
[*] BO : Merchandise Return tab is removed.
[*] BO : Room type ids now start room type id from 1 in room type render list.
[*] BO : Prestashop warning pop up will nt be shown during module installation for Webkul modules.
[*] BO : Updated addons link from store to addon's page
[*] BO : Added recomended image size for room type images for appropriate view on front end.

[*] FO : Calendar Design is improved of date from and date to in QloApps.
[*] FO : 'Proceed' button during checkout will be disabled in case of errors while checkout.
[*] FO : Search panel is improved on all pages.
[*] FO : Cart warning text changed
[*] FO : Refund request proocess is improved for the customer. Designed is also improved.

[*] CO : paypal adaptive module (by webkul) Removed completely from qloapps
[*] CO : All the irrelevant data creation from the installation process is removed Which is not related to Qloapps but Prestashop. e.g  carriers, stores, suppliers, manufacturers...... etc. Order data will not be populated now.

[*] CO : For refund request "order_return" and "order_return_detail" tables are used.
[*] CO : For order refund states "order_return_states" table is used.


## Bug/Issues Resolved:

[-] BO : FIXED : Room does not free even after room status set to checkout.
[-] BO : FIXED : Room does not free while order status is changed to Refunded, Cancelled or Payment Error.
[-] BO : FIXED : Additional facilities price id not managed while deleting a booking from admin order details page.

[-] FO : FIXED: when using advance payment option, discount voucher (amount) get applied to advance payment amount along with total order cost
[-] FO : FIXED : If all rows are disabled then also blocks (Interior, Rooms, Features, Testimonials) are visible on home page.
[-] FO : FIXED : Zip code error while making the guest check.
[-] FO : FIXED : Issue while creating a customer/guest from checkout page on firefox browser.
[-] FO : FIXED : Check-out date same as check-in date when current data is more than max order date for hotel
[-] FO : FIXED : customer able to process booking for inactive rooms
[-] FO : FIXED : Image strech issue on product page.
[-] FO : FIXED : Cart page not update when delete from from cart dropdown
[-] FO : FIXED : While making the guest check out the system shows zip code error in some countries.

[-] CO : FIXED : Fatal error: Uncaught exception 'ImagickException' while creating invoice.
[-] CO : FIXED : warning while creating invoice (total demands variable issue)


####################################
# V1.4.1
####################################

## Added Features:

[+] BO : Hotel wise employee permission management is added. now admin can give permission to his employees according to the specific hotel selections

[+] BO : Additional facility : functionality is added at backoffice order creation process also.
[+] BO : Additional facility : Tax can be applied on additional facilities.
[+] BO : Additional facility : Per day price calculation option is added.[Price will be calculated on per day basis of the booking or for entire date range of the booking]
[+] BO : Order Confirmation Email : Now admin can set to whom order confirmation email will be sent from Preferences -> orders tab.
[+] CO : displayNavigationBottomHook hook added "hotelcommerce/modules/blockuserinfo/nav-xs.tpl".

## Improved/changed features:

[*] FO : Address details on Order details page is changed. Only details (name, email and mobile number) will be shown which we are showing to the customer at checkout page
[*] FO : Address will not be shown to the customer while checkout process. edit link also removed from "Guest Information" section at checkout page.

[*] BO : Option to delete one room in two default created rows in while saving rooms of the room type.
[*] BO : unit price fields removed from backoffice room type creation page.

[*] CO : blocknavigationmenu : Navigaion menu improved. All links are dynamic now.
[*] CO : wkfooterexploreblock module is removed. All functionalities are merged with blocknavigationmenu module.
[*] CO : Orders will be splitted now hotelwise. A new order will be created for each hotel.
[*] CO : Trademark and powered by changed to webkul (from presatshop).
[*] CO : Correct single quotes and double quotes of Class HotelBookingDetail.php
[*] CO : Installed paypal module by prestashop by default while QloApps installation.
[*] CO : Translations are improved.

## Bug/Issues Resolved:

[-] BO : Resolved : Room does not free even after room status set to checkout.
[-] BO : Resolved : Infinite loop on Room type page while loading Booking Information tab.
[-] BO : Resolved : Book now page showing error when current date is last date of the month.
[-] BO : Resolved : Image is not showing while feature update (Catalog->features) and issue while updating feature.

[-] CO : Resolved : As theme name was "hotel-theme". So on saving theme translations a new theme directory "hotel-theme" is created and translations are saved in this directory. now "hotel-theme" is replaced with "hotel-reservation-theme".
[-] CO : Resolved : Feature price plans not working. [ Create two plans one for sunday and other for saturday. At the moment it's only showing the change/increase on Saturdays not Sundays. If I unable Saturdays it is showing the price change on Sundays and not Saturdays.
[-] CO : Resolved : Order status is 'Payment Error' if payment is done by advance payment with real payment gateways.

[-] FO : Resolved : blockcart and blocknavigationmenu modules swaps randomly at displayTop hook.
[-] FO : Resolved : Disable dates of last room will be saved for all previous rooms while saving rooms of a room type.
[-] FO : Resolved : Rooms are not visible when changing minimum price in filter by price.
[-] FO : Resolved : Null quantity issue when check-in date and check-out dates are the same. When the date_from and the date_to passed in the URL parameter are identical they are accepted in the entries (Check-In Date & Check-out Date) on the room type detail page. Once we click on Book now pop up with "Null quantity" message appears.


####################################
# V1.4.0
####################################

## Added Features:

[+] CO : Additional facilities functionality is added.
[+] CO : Almost all updates added to QloApps till the prestashop version 1.6.1.23.


## Improved/changed features:

[*] CO : Tools::generateHtaccess() improved
[*] CO : ($round = true) parameter added in Tools::convertPriceFull()
[*] CO : Localization updated
[*] CO : mails/en/product_download.txt bug resolved
[*] CO : swiftMailer version updated to 5.2.2
[*] CO : translations updated
[*] CO : config/config.inc.php improved (smarty early inclusion)
[*] CO : config/smarty.config.inc.php improved (smartyHook() return improved)
[*] CO : Security: Use Mcrypt’s CBC mode instead of the ECB mode.

[*] CO : Almost all improvements/changes features added to QloApps till the prestashop version 1.6.1.23.
[*] BO : All Stats Module compatible with QloApps

[*] FO : Room type details Page Design improved

## Bug/Issues Resolved:

[-] CO : Almost all bugs resolved in QloApps till the prestashop version 1.6.1.23.
[-] CO : Resolved :: QloApps Compatible with MySQL 5.7


####################################
# V1.3.2
####################################

## Added Features:

[+] CO : pscleaner module is added for cleaning demo data from QloApps.

[+] FO : Option for Guest checkout is given at Preferences->Orders tab. So Guest Checkout is enabled.

[+] FO : Option for Shorter registration/address form is given at Preferences->Customers tab. (In this case address will be created from customer chosen room type's hotel address automatically).

[+] CO : wkfooterexploreblock :: Admin can add custom explore links to show at footer explore block and navigation menu also. table  'htl_custom_explore_link' added with multilang.

## Improved/changed features:

[-] BO : New category option from "quick access" links is removed.
[+] FO : Checkout page design has been changed.
[+] CO : Images validation improved.


## Bug/Issues Resolved:

[-] CO : 56% Installation issue.

[-] BO : Dashboard graphs not loading issues on php 7.2
[-] BO : feature update issue on not selecting image while updating the feature.
[-] BO : Category bug resolve (Should not be created updated deleted from anywhere). Will be handled from hotel creation/updation/deletion.


####################################
# V1.3.1
####################################

## Added Features:

[+] BO : All already compatible Stats module are installed to the qloapps now.


## Improved/changed features:

[+] BO : Hotel name is shown in the Room Type Booking list and Room Type booking status tables.
[+] FO : Hotel name is shown in the Customer shopping list, Order confirmation and order details booking lists.


## Bug/Issues Resolved:

[-] CO : Resolved :: When set up the new install, the upload_max_filesize value in the php.ini file less than 16M, but the error message is displaying for memory_limit.


####################################
# V1.3.0
####################################

## Added Features:

[+] CO : Qloapps is compatible with php 7.x.x .


## Improved/changed features:

[+] CO : "create demo data or not" option improved for Qloapps demo data .
[+] CO : System compatibility check for Qloapps installation improved .



####################################
# V1.2.0
####################################

## Added Features:

[+] CO : Qloapps is now GDPR compatible (changes are made in Qloapps according to Qloapps GDPR module).
[+] CO : wkfooterpaymentblock :: Created a controller where admin will be able to create payment Blocks.
[+] CO : wkfooterpaymentblock :: Admin will be able to enter Name , image and status of the payment block.
[+] CO : wkfooterpaymentblock :: Admin will be able to position the payment blocks and payment image blocks will be shown to the customer as per their positions.
[+] CO : Qloapps version compliancy code added for modules' installation

[+] FO : On contact us page, design is changed.
[+] FO : On contact us page contact header, contact content, global address are now dynamic. Enter values from AdminGeneralSettingsController.

[+] BO : Configuration to show/hide only one active hotel is added in location search panel in Hotel General Settings.


## Improved/changed features:

[+] CO : Missing multilang fields added where needed in Qloapps.
[+] CO : Tax name will be shown in the invoices now. (For GST purposes) - (enable tax breakdown is mandatory)
[+] CO : logo.gif needed in the modules (module author:webkul)
[+] CO : Removed prestashop from all the pages and emails of Qloapps.
[+] CO : Changed all links of Qloapps according to the qloapps.com.
[+] CO : Stopped sending info to prestashop while installation.

[+] BO : Seperate configuration panel is made for location search panel in Hotel General Settings.


## Bug/Issues Resolved:

[-] CO : Resolved :: Theme compilation issue on ajax while Qloapps installation
[-] CO : Resolved :: Notice on Calls to functions Product::getProducts() in wkhoteleoom and Product::getSimpleProducts() in HotelHelper.php while installation of Qloapps.[Trying to get property of non-object]

[-] CO : Resolved :: hotelreservationsystem - Parent:: replaced with parent:: in classes/hotelHotelBranchInformation.php which was creating problems in installation.

[-] CO : Resolved :: RecursiveDirectoryIterator::__construct(/var/www/html/themes/hotel-reservation-theme/): failed to open dir While installation.

[-] BO : Resolved :: hotelreservationsystem:: Hotel images not saved while saving hotel details.
[-] BO : Resolved :: hotelreservationsystem - $max_phone_digit is undefined issue resolved on hotel creation form.
[-] BO : Resolved :: hotelreservationsystem:: HotelBookingDetail.php : phone number sent as string '0987654321'from 0987654321. Giving error while installing Qloapps with php7.0.0 .

[-] BO : Resolved :: wktestimonialblock:: Error while saving or updating testimonials by admin.
[-] BO : Resolved :: array_column is removed from AdminProductController [php version compatibility issue].

[-] FO : Resolved :: Undefined index: total_rooms_in_cart at blockcart.tpl.


####################################
# V1.1.1
####################################

## Added Features:

[+] FO : FrontController.php - Breadcrump code added for front end controllers.
[+] FO : FrontController.php - timepicker/jquery-ui-timepicker-addon.js')) added for timepicker on front end.
[+] FO : FrontController.php - growl plugin added for growl notifications on front end.

[+] FO : global.css - text-danger, text-warning..... color css added.
[+] FO : global.css - Css added for growl notification.
[+] FO : global.css - a:hover, a:focus css added at line no. : 265 Text invisible on hover, focus.
[+] FO : global.css - Css for different Badges added.

[+] FO : global.js - showSuccessMessage(), showErrorMessage(), showNoticeMessage() added for growl Notification in front end.
[+] FO : global.js - showSuccessMessage(), showErrorMessage(), showNoticeMessage() added for growl Notification in front end.



## Improved/changed features:

[+] CO : displayCustomerAccountAfterTabs hook added at my-account.tpl .
[+] CO : actionPackageListGenerateOrder hook added at PaymentModule.php .
[+] CO : changes for the hotel search panel(id_hotel sent in the ajax request) in product.tpl
[+] CO : getAllOrdersByCartId() added Order.php
[+] CO : initContent() changes for seller wise split order feature in OrderConfirmationController.php
[+] CO : changes for seller wise split order feature in Order_confirmation.tpl
[+] CO : Automatic module upgradation is now disabled.

[*] MO : hotelreservationsystem.php : hookActionProductDelete()  updated.
[*] MO : hotelreservationsystem.php : hookActionValidateOrder()  updated for seller wise split changes.
[*] MO : hotelreservationsystem->HotelBranchInformation.php : update()  overrided.
[*] MO : hotelreservationsystem->HotelBranchInformation.php : delete()  overrided.
[*] MO : hotelreservationsystem->HotelBranchInformation.php : addCategory() function moved from controllers.
[*] MO : hotelreservationsystem->HotelImage.php : validateImage, validAddHotelOtherImage, uploadOtherImages, uploadMainImage, randomImageName functions removed.
[*] MO : hotelreservationsystem->HotelAdvancedPayment.php : getOrderMinAdvPaymentAmount($id_order) added.
[*] MO : hotelreservationsystem->HotelCustomerAdvancedPayment.php : getClientAdvPaymentDtl() and getOrderTotal changed for make compatible for sellerwise split order.
[*] MO : hotelreservationsystem->HotelImage.php : uploadHotelImages() is added.
[*] MO : hotelreservationsystem->HotelRoomInformation.php : getIdProductByHotelId() is added.
[*] MO : hotelreservationsystem->HotelRoomInformation.php : getHotelCategoryTree() is updated.
[*] MO : hotelreservationsystem->HotelRoomInformation.php : Overrided delete() function and added a new function which will run at the time of delete function execute.
[*] MO : hotelreservationsystem->HotelRoomDisableDates.php : validateDisableDateRange() is added.
[*] MO : hotelreservationsystem->HotelBookingDetails.php : UpdateHotelCartHotelOrderOnOrderEdit() is added changes in getOnlyOrderBookingData()
[*] MO : hotelreservationsystem->HotelCustomerAdvancedPayment.php : updateAdvancePaymentInfoOnOrderEdit() is added.
[*] MO : hotelreservationsystem->HotelRoomInformation.php : commented code is removed.
[*] MO : hotelreservationsystem->HotelRoomTypeFeaturePricing.php :deleteFeaturePriceByIdProduct(),  getFeaturePriceInfo() are added.
[*] MO : hotelreservationsystem->HotelBookingDetails.php : getBookingData() ..... $room_type = 0 (default value of room_type added)

[+] CO : hotelreservationsystem::AdminAddHotelController.php - addCategory() is moved at HotelBranchInformation.php and image save changes.
[+] CO : hotelreservationsystem::AdminProductsController.php - ajaxProcessDeleteHotelRoom() changed.
[+] CO : hotelreservationsystem::AdminHotelRoomsBookingController.php - renderView() changes for booking data is null.
[+] CO : hotelreservationsystem::AdminHotelFeaturePricesSettings.php - Below code is removed because impact price can be greater then 100% : if ($priceImpactType == 1) {
    if ($impactValue > 100) {
        $this->errors[] = $this->l('Invalid value of impact percentage.');
    }
}

[+] CO : wkroomsearchblock::autocompletesearch.php - changes for the hotel search panel(id_hotel sent in the ajax request).

[+] CO : bankwire::bankwire.php - hookPaymentReturn() changed (seller wise order split).
[+] CO : cheque::cheque.php - hookPaymentReturn() changed (seller wise order split).

[+] CO : hotelreservationsystem - double codes remove in form.tpl(modules/hotelreservationsystem/views/templates/ admin/ hotel_feature_prices_settings/helpers/form/form.tpl)
[+] CO : hotelreservationsystem::AdminHotelRoomsBookingController: form.tpl - renderView() changes for booking data is null.
[+] CO : hotelreservationsystem::from.tpl :: AdminAddHotelController.php - Changes for tabs (hotel information and images tabs)
[+] CO : hotelreservationsystem::roomSearchWrapper.tpl - changes for the hotel  search panel (id_hotel sent in the ajax request)
[+] CO : htlfiltersearchblock::htlfiltersearchblock.tpl - changes for the hotel  search panel (id_hotel sent in the ajax request)


[+] CO : hotelreservationsystem::HotelReservationAdmin.css - css added For images save and delete


[+] CO : hotelreservationsystem::HotelReservationAdmin.js - js added For images save and delete changes
[+] CO : hotelreservationsystem::HotelReservationAdmin.js - For booking Calendar and datepicker changes when booking data is null
[+] CO : hotelreservationsystem::roomSearchBlock.js - changes for the hotel  search panel (id_hotel sent in the ajax request)


## Bug/Issues Resolved:

[-] BO : Resolved :: submitHandler: function(form) removed at line 257 (admin/themes/default/template/controllers/product/form/form.tpl) o resolve Room Type not always saved while saving fron the backoffice.

[+] CO : wkhotelroom::WkHotelRoomDisplay.php - deleteRoomByIdProduct() function is turned to static becuase at the time of product delete this function is throwing error.


####################################
# V1.1.0
####################################

## Added Features:

[+] Project : `source` column is added in the `order` table to show the source of the booking.

[+] Project : Everywhere now prices are shown according to the feature prices.

[+] Project : Everywhere prestashop logo is replaced with Qloapps logo

[+] BO : Feature price plans functionality has been added.
[+] BO : Funnctionality to disable rooms for many dates is added.
[+] BO : processConfiguration(), initFormConfiguration() are modified and validateDisableDateRanges() is added for disabled dated functionality in AdminProductsController.
[+] BO : AdminOrdersController is modified for feature price funtionality. renderview and renderform functions also modified to display according to feature prices.

[+] FO : OrderConfirmationController, OrderOpcController, OrderDetailsController and ProductControler are modified for feature price functionality. display files of the controllers also modified.

[+] CO : hotelreservationsystem : ChannelManagerServices.php is added.
[+] CO : hotelreservationsystem : ChannelOrderPayment.php is added.
[+] CO : hotelreservationsystem : HotelCustomerAdvancedProductPayment.php is added.
[+] CO : hotelreservationsystem : HotelRoomDisableDates.php is added.
[+] CO : hotelreservationsystem : QloWebservice.php is added.
[+] CO : hotelreservationsystem : WebserviceSpecificManagementQlo.php is added.

[+] CO : hotelreservationsystem : ChannelManagerServices.php is added.
[+] CO : hotelreservationsystem : HotelRoomTypeFeaturePricing.php is added.
[+] CO : hotelreservationsystem : ChannelOrderPayment.php is added.
[+] CO : hotelreservationsystem : getRoomMinAdvPaymentAmount() is added in HotelAdvancedPayment.php.
[+] CO : hotelreservationsystem : createQloAppsBookingByChannels(), createQloCustomerChannelCustomerInfo(), 									createQloCustomerAddressByChannelCustomerInfo(), createQloCartForBookingFromChannel(), ProcessCreateQloOrderForChannelBooking() 		are added for Qloapps Api need  in HotelBookingDetails.php.
[+] CO : hotelreservationsystem : 'total_price_tax_excl' and 'total_price_tax_incl' columns are added in `htl_booking_detail` table to 										store the booking time price.
[+] CO : hotelreservationsystem : getProductFeaturePricePlanByDateByPriority(), getHotelCartBookingData() are added in 													HotelCartBookingData.php.
[+] CO : hotelreservationsystem : 'disabled_dates' column is added in the table `htl_room_information`.
[+] CO : hotelreservationsystem : getRoomTypeAvailableRoomsForDateRange(), getRoomTypeDisabledRoomsForDateRange(), 														getRoomTypeBookedRoomsForDateRange() are added in HotelRoomInformation.php.
[+] CO : hotelreservationsystem : room status 'Hold For Maintenance is replace with 'Temporary incative';
[+] CO : hotelreservationsystem : AdminHotelRoomsBookingController.php and AdminOrderRefundRequestsController.php are changed to make 										compatible with feature price functionality.

## Improved/changed features:

[*] MO : wkhotelroom : price of the room types are shown at home page according to feature price plans.
[*] FO : price of the room types are shown at home page according to feature price plans.


## Bug/Issues Resolved:

[-] FO : Resolved :: issue on saving Room type information at admin product information. On saving product sometimes redirecting to renderlist.
[-] FO : Resolved :: If admin left the 'max global date field' to be blank,then invalid dates are shown in check in-checkout fields at frontend.
[-] FO : Resolved :: On submitting the total order cancellation request,Popup with "Parser error text" is shown. (If submit request for single room first and then for all the rooms in the order).
[-] BO : Resolved :: Some validation issues on manage order refund rules page.
[-] BO : Resolved :: Room type column  added on manage order refund request -> view page. (#158)
[-] BO : Resolved :: Advance paid amount on "manage order refund request view page" is shown for the single room.(#150)
[-] BO : Resolved :: If admin deleted the room from "order detail page",then errors are shown on the "customer order detail page".(#137)
[-] BO : Resolved :: While reallocating the rooms,sometimes the JSON is getting breakable,due to which no room is shown for swapping & reallocation.(#133)
[-] FO : Resolved :: While placing an order,if customer signed out on "order summary page",then error is shown. (#119)
[-] FO : Resolved :: If filtered with any parameter on category page,then on clicking the 'Book now button',page is redirecting to the category page itself.(#118)
[-] FO : Resolved :: On clicking to the 'add new icon',the page is redirecting to the 'assign features page' rather than 'add new features page'.(#106)
[-] BO : Resolved :: While adding the hotel features,no success message is shown on add new features-> manage hotel features page. (#105)
[-] BO : Resolved :: hotel interior heading and description are not changing on saving new ones.(#87)
[-] BO : Resolved :: PlayPal..Php curl issue on installation. needs curl to be installed on server for istallation (#89)
[-] BO : Resolved :: Many Order Edit issues resolved.


####################################
# V1.0.1
####################################

## Improved/changed features:

[+] Project : Theme has been improved.

[*] FO : After selecting checkIn and checkout dates these dates are highlighted in the datepicker.
[*] FO : contact Number and email were hard coded on contact page now will dinamically come from entered values from Admin General Configuration.
[*] FO : Font-family in order summary page in synced with the theme fonts now.

[*] BO : Bacorder setting option is removed from Settings->General Settings.

## Fixed bugs:

[-] MO : hotelreservationsystem : Fixed Google map issue on contact page.
[-] BO : Fixed showing wrong way of payment on refund request page.
[-] BO : Fixed showing wrong cancellation charges on refund request page.
[-] MO : wkabouthotel : Fixed interior heading and description does not change on changing from Setting->Hotel interior Block Setting.


# Change Log previous version to V1.0.0:

## Added Features:

[+] Project : Theme has been improved.

[+] FO : Order summary page design improved in case of advance payment

[+] BO : Order Edit functionality is added.
[+] BO : Order Restrict functionality is added.
[+] BO : Order Edit id added.

[+] CO : wkpaypaladaptive : Added Feature Admin can refund full transaction.
[+] CO : wkpaypaladaptive : Order is created by IPN.
[+] CO : Added wkhotelroom
[+] CO : Added wkfooteraboutblock
[+] CO : Added wkfooterexploreblock
[+] CO : Added wkfooternotificationblock
[+] CO : Added wkfooterpaymentblock
[+] CO : hotelreservationsystem : Added Settings tab to centralize all configurations.


## Improved/changed features:

[+] Project : Theme has been improved.

[*] FO : Fixed partial amount calculation issues in case of advance payment at order summary page.
[*] FO : Room details page design has been improved.
[*] FO : Room search results page design has been improved.
[*] FO : Home page design has been improved.
[*] FO : Contact page design has been improved.
[*] FO : All pages design has been changed according to new theme.
[*] FO : Theme Footer design has been improved. more modules are added to improve the view.

[*] BO : Quantity tab from Catalog->products removed.
[*] BO : Tab Catalog->Attachments removed.
[*] BO : Tab Cart Rules is improved to make compatible for a hotel reservation system.
[*] BO : Gift product functionality is removed from Cart Rules to make compatible for a hotel reservation system.
[*] BO : Carrier selection functionality is removed from Cart Rules to make compatible for a hotel reservation system.
[*] BO : Compatibility with other cart rules functionality is removed from Cart Rules to make compatible for a hotel reservation system.
[*] BO : Product selection functionality is removed from Cart Rules to make compatible for a hotel reservation system.
[*] BO : Free shipping functionality is removed from Cart Rules to make compatible for a hotel reservation system.
[*] BO : Free shipping functionality is removed from Cart Rules to make compatible for a hotel reservation system.

[*] MO : wkpaypaladaptive : Order is created by IPN.
[*] MO : wkpaypaladaptive : Improved exception handling.
[*] MO : wkpaypaladaptive : Configuration of the module moved to Hotel Reservation System -> Settings Tab.
[*] MO : wkhotelfeaturesblock : Configuration of the module moved to Hotel Reservation System -> Settings Tab.
[*] MO : wktestimonialblock : Configuration of the module moved to Hotel Reservation System -> Settings Tab.
[*] MO : wkhotelfilterblock : Configuration of the module moved to Hotel Reservation System -> Settings Tab.
[*] MO : wkroomsearchblock : design changed on home page.



## Fixed bugs:

[-] PROJECT : Fixed anonymous object creation issue on php version lower than 5.4 (feature does not support before php version 5.4).

[-] Installer : Fixed changed mails for qloapps converted into prestashop default mails while installing the software.

[-] FO : Fixed if 'Product Comment' module is uninstalled then showing error on each page at frontend where rating is shown.
[-] FO : Fixed bug search is not working on iphones.
[-] FO : Reservations of dates before today's date does not remove from Cart.
[-] FO : Fixed bug search is not working on iphones.
[-] FO : Fixed 'Total Order Cancellation' & 'Refund Request' button does not work on order confirmation page on some servers.
[-] FO : Fixed in case when hotel is disabled and its rooms are enabled then showing error on room detail page.
[-] FO : Fixed Contact us page at frontend is not working.
[-] FO : Fixed link creation functions by creating them with objects created by sending id_lang also to their constructor.


[-] BO : Fixed wrong "way of payment" issue regarding advance payment On Hotel Reservation System->Manage Order Refund Requests.
[-] BO : Fixed wrong "way of payment" issue regarding advance payment On Hotel Reservation System->Manage Order Refund Requests.
[-] BO : Fixed bug Cancellation charge is accepting the -ve value so the refund amount becomes more than total amount.
[-] BO : Fixed view option is coming twice on manage order refund requests-> view page.
[-] BO : Fixed Showing error 'Order->id_customer is empty' on admin order detail page after completing the order from backoffice.
[-] BO : Fixed bug how number of times admin clicks add to cart button,same no. of times the room gets added into the cart from Hotel Reservation System->Book Now tab.
[-] BO : Fixed issue if Tax is applied on the order even then Tax is shown 0 in admin order detail page.
[-] BO : Fixed error if enter numeric data in child feature field while adding the new hotel feature on 'Manage Hotel Features' page.
[-] BO : Fixed all filters on 'Manage hotel features page' are showing errors.
[-] BO : Fixed all filters on Manage hotel page showing error.
[-] BO : Fixed if deleting the hotels through 'bulk actions dropdown' then showing error.
[-] BO : Fixed If set 'disable for 'enable hotel' option while adding the hotel showing error page.
[-] BO : Fixed bug if update Order's room status(checking, allotted or checkout) all rooms status changed with same room number of same room type.
[-] BO : Fixed bug if update Order's room status(checking, allotted or checkout) all rooms status changed with same room number of same room type.


[-] MO : wktestimonialblock : Fixed while adding the image in valid format on configuration page then showing error page.
[-] MO : wkpaypaladaptive : Fixed paypal is not working because paypal api has been changed.
[-] MO : wkpaypaladaptive : Fixed fopen issues fixed, done by CURL.
[-] MO : wkpaypaladaptive : Fixed payment negative value bug fixed.
